# 
#
# Generated by dumpDCWorkflow.py written by Sebastien Bigaret
# Original workflow id/title: groupspace_content_shared_workflow/Shared Content Workflow [GroupSpaces]
# Date: 2005/10/20 21:43:33.734 GMT+2
#
# WARNING: this dumps does NOT contain any scripts you might have added to
# the workflow, IT IS YOUR RESPONSABILITY TO MAKE BACKUPS FOR THESE SCRIPTS.
#
# No script detected in this workflow
# 
"""
Programmatically creates a workflow type
"""
__version__ = "$Revision: 1.1 $"[11:-2]

from Products.CMFCore.WorkflowTool import addWorkflowFactory

from Products.DCWorkflow.DCWorkflow import DCWorkflowDefinition

def setupGroupspace_content_shared_workflow(wf):
    "..."
    wf.setProperties(title='Shared Content Workflow [GroupSpaces]')

    for s in ['shared']:
        wf.states.addState(s)
    for t in []:
        wf.transitions.addTransition(t)
    for v in ['action', 'time', 'comments', 'actor', 'review_history']:
        wf.variables.addVariable(v)
    for l in ['reviewer_queue']:
        wf.worklists.addWorklist(l)
    for p in ('Access contents information', 'Modify portal content', 'View', 'List folder contents'):
        wf.addManagedPermission(p)
        

    ## Initial State
    wf.states.setInitialState('shared')

    ## States initialization
    sdef = wf.states['shared']
    sdef.setProperties(title="""Shared Folder for the participants of the GroupSpace""",
                       transitions=())
    sdef.setPermission('Access contents information', 0, ['GroupAdmin', 'GroupLeader', 'GroupMember', 'GroupVisitor', 'Manager'])
    sdef.setPermission('Modify portal content', 0, ['GroupAdmin', 'GroupLeader', 'GroupMember', 'Manager'])
    sdef.setPermission('View', 0, ['GroupAdmin', 'GroupLeader', 'GroupMember', 'GroupVisitor', 'Manager'])
    sdef.setPermission('List folder contents', 0, ['GroupAdmin', 'GroupLeader', 'GroupMember', 'GroupVisitor', 'Manager'])


    ## Transitions initialization
    ## State Variable
    wf.variables.setStateVar('review_state')

    ## Variables initialization
    vdef = wf.variables['action']
    vdef.setProperties(description="""The last transition""",
                       default_value="""""",
                       default_expr="""transition/getId|nothing""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    vdef = wf.variables['time']
    vdef.setProperties(description="""Time of the last transition""",
                       default_value="""""",
                       default_expr="""state_change/getDateTime""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    vdef = wf.variables['comments']
    vdef.setProperties(description="""Comments about the last transition""",
                       default_value="""""",
                       default_expr="""python:state_change.kwargs.get('comment', '')""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    vdef = wf.variables['actor']
    vdef.setProperties(description="""The ID of the user who performed the last transition""",
                       default_value="""""",
                       default_expr="""user/getId""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    vdef = wf.variables['review_history']
    vdef.setProperties(description="""Provides access to workflow history""",
                       default_value="""""",
                       default_expr="""state_change/getHistory""",
                       for_catalog=0,
                       for_status=0,
                       update_always=0,
                       props={'guard_permissions': 'Request review; Review portal content'})

    ## Worklists Initialization
    ldef = wf.worklists['reviewer_queue']
    ldef.setProperties(description="""Reviewer tasks""",
                       actbox_name="""Pending (%(count)d)""",
                       actbox_url="""%(portal_url)s/search?review_state=pending""",
                       actbox_category="""global""",
                       props={'guard_permissions': 'Review portal content', 'var_match_review_state': 'pending'})


def createGroupspace_content_shared_workflow(id):
    "..."
    ob = DCWorkflowDefinition(id)
    setupGroupspace_content_shared_workflow(ob)
    return ob

addWorkflowFactory(createGroupspace_content_shared_workflow,
                   id='groupspace_content_shared_workflow',
                   title='Shared Content Workflow [GroupSpaces]')

    
